<template>
  <div id="layout">
    <div v-if="loaded === false" class="container">
      <Header/>
    </div>
    <div v-else class="container">
      <Main :data="this.data"></Main>
      <Second :data="this.data" :sunrise="this.sunrise" :sunset="this.sunset"></Second>
    </div>
    <div class="search-bar">
      <label>
        <input v-on:keydown.enter="fetchData()" v-model="query" type="text" placeholder="Recherche">
      </label>
      <v-icon v-on:click="fetchData()" name="search"/>
    </div>
  </div>
</template>

<script>
import Header from '@/components/weatherApp/Header.vue';
import Main from '@/components/weatherApp/Main.vue';
import Second from '@/components/weatherApp/Second.vue';
import Axios from 'axios';

export default {
  name: 'Layout',
  components: {
    Header,
    Main,
    Second,
  },
  data() {
    return {
      apiKey: '0fb35293748be903cbaa5f2a734071fa',
      query: null,
      loaded: false,
      data: {},
      sunrise: null,
      sunset: null,
    };
  },
  methods: {
    async fetchData() {
      await Axios
        .get(`https://api.openweathermap.org/data/2.5/weather?q=${this.query}&units=metric&appid=${this.apiKey}&lang=fr`)
        .then((response) => {
          this.data = response.data;
        });
      this.loaded = true;
      const windIcon = document.querySelector('.wind-icon');
      windIcon.setAttribute('style', `transform: rotate(${this.data.wind.deg}deg)`);
      this.sunrise = `${(new Date(this.data.sys.sunrise)).getHours()}h${(new Date(this.data.sys.sunrise)).getMinutes()}`;
      this.sunset = `${(new Date(this.data.sys.sunset)).getHours()}h${(new Date(this.data.sys.sunset)).getMinutes()}`;
    },
  },
};
</script>

<style lang="scss">
#layout {
  display: flex;
  flex-direction: column;
  justify-content: space-around;
  width: 100%;
  height: 100vh;

  .container {
    display: flex;
    flex-direction: column;
  }

  h1 {
    font-size: 48px;
  }

  h2 {
    font-size: 36px;
  }

  h3,
  h4 {
    font-size: 24px;
  }

  p {
    font-size: 18px;
  }

  .search-bar {
    display: flex;
    align-items: center;
    margin: 0 auto;

    svg {
      width: 25px;
      height: 25px;
      margin-left: 1rem;
    }

    label {

      input {
        width: 250px;
        padding: 5px 10px;
        font-size: 18px;
        text-align: center;
        border-radius: 15px;
        border: 2px solid #000;

        &:focus {
          outline: none;
        }
      }
    }
  }
}
</style>
